Reinforcement BentShapeRebar: Difference between revisions

From FreeCAD Documentation
(400px image)
(Marked this version for translation)
(20 intermediate revisions by 6 users not shown)
Line 2: Line 2:
<translate>
<translate>
<!--T:1-->
<!--T:1-->
{{Docnav
|[[Arch_Rebar_LShape|LShape Rebar]]
|[[Arch_Rebar_Stirrup|Stirrup Rebar]]
|[[Arch_Module|Arch]]
|IconL=Arch_Rebar_LShape.svg
|IconC=Workbench_Arch.svg
|IconR=Arch_Rebar_Stirrup.svg
}}

<!--T:28-->
{{GuiCommand
{{GuiCommand
|Name=Arch Rebar BentShape
|Name=Arch Rebar BentShape
|MenuLocation=Arch → Rebar tools
|MenuLocation=Arch → Rebar tools → Bent-Shape Rebar or 3D/BIM → Reinforcement → Bent-Shape Rebar
|Workbenches=[[Arch Workbench|Arch]], [[BIM Workbench|BIM]]
|Workbenches=[[Arch_Workbench|Arch]], [[BIM_Workbench|BIM]]
|SeeAlso=[[Arch_Rebar_Stirrup|Stirrup Rebar]], [[Arch Rebar]]
|SeeAlso=[[Reinforcement_Workbench|Reinforcement]], [[Arch_Rebar|Arch Rebar]], [[Arch_Rebar_Stirrup|Arch Rebar Stirrup]]
|Version=0.17
|Version=0.17
}}
}}
Line 13: Line 23:


<!--T:3-->
<!--T:3-->
The [[Arch Rebar BentShape|BentShape Rebar]] tool allows the user to create a set of bent reinforcing bars inside an [[Arch Structure]] object.
The [[Arch_Rebar_BentShape|BentShape Rebar]] tool allows the user to create a set of bent reinforcing bars inside an [[Arch_Structure|Arch Structure]] object.


<!--T:29-->
This command is part of the [[Reinforcement Addon]], that you can install with the [[Addon Manager]], via the menu {{MenuCommand|Tools → Addon manager → Reinforcement}}.
The [[Arch_Rebar_BentShape|BentShape Rebar]] tool is also integrated into [[BIM_Workbench|BIM Workbench]].

<!--T:19-->
This command is part of the [[Reinforcement Workbench|Reinforcement Workbench]], an [[External workbenches|external workbench]] that can be installed with the [[Image:AddonManager.svg|24px]] [[Addon Manager|Addon Manager]] via the {{MenuCommand|Tools → Addon manager → Reinforcement}} menu.


</translate>
</translate>
Line 21: Line 35:
<translate>
<translate>
<!--T:4-->
<!--T:4-->
{{Caption|Two sets of bent reinforcement bars inside an [[Arch Structure]]}}
{{Caption|Two sets of bent reinforcement bars inside an [[Arch Structure|Arch Structure]]}}


==How to use== <!--T:5-->
==Usage== <!--T:5-->


<!--T:6-->
<!--T:6-->
# Select any face of a previously created {{Button|[[Image:Arch_Structure.svg|16px]] [[Arch Structure]]}} object.
# Select any face of a previously created {{Button|[[Image:Arch_Structure.svg|16px]] [[Arch Structure|Arch Structure]]}} object.
# Then select {{Button|[[Image:Arch_Rebar_BentShape.svg|16px]] [[Arch Rebar BentShape|BentShape Rebar]]}} from the rebar tools.
# Then select {{Button|[[Image:Arch_Rebar_BentShape.svg|16px]] [[Arch Rebar BentShape|BentShape Rebar]]}} from the rebar tools.
# A task panel will pop-out on the left side of the screen as shown below.
# A [[task panel]] will pop-out on the left side of the screen as shown below.
# Select the desired orientation.
# Select the desired orientation.
# Give the inputs like front cover, left cover, right cover, bottom cover, top cover, anchor length, bent angle, rounding and diameter of the rebar.
# Populate the inputs like 'Left Cover', Right Cover, Top Cover, 'Bottom Cover', 'Front Cover', 'Bent Angle', 'Bent Factor', 'Rounding' and 'Diameter' of the rebar.
# Select the mode of distribution either amount or spacing.
# Select the mode of distribution either 'Amount' or 'Spacing'.
# If spacing is selected, a user can also opt for [[Custom_Spacing|custom spacing]].
#* If 'Spacing' is selected, a user can also opt for [[Custom_Spacing|custom spacing]].
# Pick selected face is used to verify or change the face for rebar distribution.
# {{Button|Pick Selected Face}} is used to verify or change the face for rebar distribution.
# Click {{Button|OK}} or {{Button|Apply}} to generate the rebars.
# Click {{Button|OK}} or {{Button|Apply}} to generate the rebars.
# Click {{Button|Cancel}} to exit the task panel.
# Click {{Button|Cancel}} to exit the task panel.


<!--T:20-->
[[Image:BentShapeDialog.png|250px]]
:[[Image:BentShapeDialog.png|250px]]
{{Caption|Taskview panel for the Arch Rebar BentShape tool}}
{{Caption|Taskview panel for the Arch Rebar BentShape tool}}


Line 55: Line 70:


==Scripting== <!--T:9-->
==Scripting== <!--T:9-->
{{Emphasis|See also:}} [[Arch API|Arch API]], [[Reinforcement API|Reinforcement API]] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].


<!--T:10-->
<!--T:10-->
The {{Button|[[Image:Arch_Rebar_BentShape.png|16px]] Bent Shape Rebar}} tool can by used in [[macros]] and from the python console by using the following function:
The BentShape Rebar tool can be used in [[macros|macros]] and from the [[Python|Python]] console by using the following function:

</translate>
</translate>
{{Code|code=
{{Code|code=
Rebar = makeBentShapeRebar(f_cover, b_cover, l_cover, r_cover,
makeBentShapeRebar(FrontCover, BottomCover, LeftCover, RightCover, Diameter, TopCover, BentLength, BentAngle, Rounding, AmountSpacingCheck, AmountSpacingValue, Orientation, Structure, Facename)
diameter, t_cover, bentLength, bentAngle, rounding, amount_spacing_check, amount_spacing_value, orientation="Bottom",
structure=None, facename=None)
}}
}}
<translate>
<translate>

<!--T:15-->
<!--T:15-->
* Creates a {{incode|Rebar}} object from the given {{incode|structure}}, which is an [[Arch Structure|Arch Structure]], and {{incode|facename}}, which is a face of that structure.
* The Bent Shape Rebar have four different orientations:
** If no {{incode|structure}} nor {{incode|facename}} are given, it will take the user selected face as input.
** Bottom
* {{incode|f_cover}}, {{incode|b_cover}}, {{incode|l_cover}}, {{incode|r_cover}}, and {{incode|t_cover}} are inner offset distances for the rebar elements with respect to the faces of the structure. They are respectively the front, bottom, left, right, and top offsets.
** Top
* {{incode|diameter}} is the diameter of the reinforcement bars inside the structure.
** Left
* {{incode|rounding}} is the parameter that determines the bending radius of the center reinforcement bars.
** Right
* {{incode|bentLength}} and {{incode|bentAngle}} define the length of the tip of the reinforcement bars, and the bending angle from the center bars.
* Adds a Bent Shape reinforcing bar object to the given structural object.
* {{incode|amount_spacing_check}} if it is {{incode|True}} it will create as many reinforcement bars as given by {{incode|amount_spacing_value}}; if it is {{incode|False}} it will create reinforcement bars separated by the numerical value of {{incode|amount_spacing_value}}.
* If no Structure and Facename is given, it will take user selected face as input.
* {{incode|amount_spacing_value}} specifies the number of reinforcement bars, or the value of the separation between them, depending on {{incode|amount_spacing_check}}.
* Here CoverAlong argument is having type tuple.
* {{incode|orientation}} specifies the orientation of the rebar; it can be {{incode|"Bottom"}}, {{incode|"Top"}}, {{incode|"Left"}}, or {{incode|"Right"}}.
* Returns the new Rebar object.

=== Example === <!--T:21-->
</translate>
</translate>
{{Code|code=
import FreeCAD, Arch, BentShapeRebar

Structure = Arch.makeStructure(length=1000, width=1000, height=100)
Structure.ViewObject.Transparency = 80
FreeCAD.ActiveDocument.recompute()

Rebar = BentShapeRebar.makeBentShapeRebar(50, 20, 20, 20,
8, 40, 100, 135, 2, True, 4, "Bottom", Structure, "Face4")
Rebar.ViewObject.ShapeColor = (0.9, 0.0, 0.0)

Rebar2 = BentShapeRebar.makeBentShapeRebar(50, 40, 20, 20,
8, 20, 100, 135, 2, True, 4, "Bottom", Structure, "Face6")
Rebar2.ViewObject.ShapeColor = (0.0, 0.0, 0.9)
}}
<translate>
<translate>

<!--T:16-->
=== Edition of the rebar === <!--T:22-->
Example:

Creating Bent Shape rebar.
<!--T:23-->
You can change the properties of the rebar with the following function

</translate>
</translate>
{{Code|code=
{{Code|code=
editBentShapeRebar(Rebar, f_cover, b_cover, l_cover, r_cover,
import Arch, BentShapeRebar
diameter, t_cover, bentLength, bentAngle, rounding, amount_spacing_check, amount_spacing_value, orientation,
structure = Arch.makeStructure(length=1000.0, width=1000.0, height=100.0)
structure=None, facename=None)
structure.ViewObject.Transparency = 80
FreeCAD.ActiveDocument.recompute()
rebar = BentShapeRebar.makeBentShapeRebar(20, 20, 20, 20, 8, 20, 100, 135, 2, True, 10, "Bottom", structure, "Face1")
}}
}}
<translate>
<translate>

<!--T:17-->
<!--T:24-->
Changing properties of Bent Shape rebar.
* {{incode|Rebar}} is a previously created {{incode|BentShapeRebar}} object.
* The other parameters are the same as required by the {{incode|makeBentShapeRebar()}} function.
* {{incode|structure}} and {{incode|facename}} may be omitted so that the rebar stays in the original structure.

</translate>
</translate>
{{Code|code=
{{Code|code=
import BentShapeRebar
import BentShapeRebar

BentShapeRebar.editBentShapeRebar(rebar, 50, 50, 50, 50, 12, 20, 100, 135, 2, True, 10, "Top")
BentShapeRebar.editBentShapeRebar(Rebar, 50, 20, 20, 20,
12, 20, 100, 155, 2, True, 6, "Top")

BentShapeRebar.editBentShapeRebar(Rebar2, 50, 35, 20, 20,
12, 35, 100, 155, 2, True, 6, "Top")
}}
}}
<translate>
<translate>


<!--T:18-->
<!--T:18-->
{{Docnav
{{Arch Tools navi}}
|[[Arch_Rebar_LShape|LShape Rebar]]
{{Userdocnavi}}
|[[Arch_Rebar_Stirrup|Stirrup Rebar]]
[[Category:Reinforcement]]
|[[Arch_Module|Arch]]
|IconL=Arch_Rebar_LShape.svg
|IconC=Workbench_Arch.svg
|IconR=Arch_Rebar_Stirrup.svg
}}

</translate>
</translate>
{{Arch Tools navi{{#translation:}}}}

{{Userdocnavi{{#translation:}}}}

[[Category:Reinforcement{{#translation:}}]]

Revision as of 20:57, 23 September 2020

Arch Rebar BentShape

Menu location
Arch → Rebar tools → Bent-Shape Rebar or 3D/BIM → Reinforcement → Bent-Shape Rebar
Workbenches
Arch, BIM
Default shortcut
None
Introduced in version
0.17
See also
Reinforcement, Arch Rebar, Arch Rebar Stirrup

Description

The BentShape Rebar tool allows the user to create a set of bent reinforcing bars inside an Arch Structure object.

The BentShape Rebar tool is also integrated into BIM Workbench.

This command is part of the Reinforcement Workbench, an external workbench that can be installed with the Addon Manager via the Tools → Addon manager → Reinforcement menu.

Two sets of bent reinforcement bars inside an Arch Structure

Usage

  1. Select any face of a previously created Arch Structure object.
  2. Then select BentShape Rebar from the rebar tools.
  3. A task panel will pop-out on the left side of the screen as shown below.
  4. Select the desired orientation.
  5. Populate the inputs like 'Left Cover', Right Cover, Top Cover, 'Bottom Cover', 'Front Cover', 'Bent Angle', 'Bent Factor', 'Rounding' and 'Diameter' of the rebar.
  6. Select the mode of distribution either 'Amount' or 'Spacing'.
  7. Pick Selected Face is used to verify or change the face for rebar distribution.
  8. Click OK or Apply to generate the rebars.
  9. Click Cancel to exit the task panel.

Taskview panel for the Arch Rebar BentShape tool

Properties

  • DataOrientation: It decides the orientation of the rebar (like a bottom, top, right and left).
  • DataFront Cover: The distance between rebar and selected face.
  • DataLeft Cover: The distance between the left end of the rebar to the left face of the structure.
  • DataRight Cover: The distance between the right end of the rebar to right face of the structure.
  • DataBottom Cover: The distance between rebar from the bottom face of the structure.
  • DataTop Cover: The distance between rebar from the top face of the structure.
  • DataAnchor Length: It is the arm's length of bent shape rebar.
  • DataBent Angle: It decides angle in bent shape rebar.
  • DataAmount: The amount of rebars.
  • DataSpacing: The distance between the axes of each bar.

Scripting

See also: Arch API, Reinforcement API and FreeCAD Scripting Basics.

The BentShape Rebar tool can be used in macros and from the Python console by using the following function:

Rebar = makeBentShapeRebar(f_cover, b_cover, l_cover, r_cover,
                           diameter, t_cover, bentLength, bentAngle, rounding, amount_spacing_check, amount_spacing_value, orientation="Bottom",
                           structure=None, facename=None)
  • Creates a Rebar object from the given structure, which is an Arch Structure, and facename, which is a face of that structure.
    • If no structure nor facename are given, it will take the user selected face as input.
  • f_cover, b_cover, l_cover, r_cover, and t_cover are inner offset distances for the rebar elements with respect to the faces of the structure. They are respectively the front, bottom, left, right, and top offsets.
  • diameter is the diameter of the reinforcement bars inside the structure.
  • rounding is the parameter that determines the bending radius of the center reinforcement bars.
  • bentLength and bentAngle define the length of the tip of the reinforcement bars, and the bending angle from the center bars.
  • amount_spacing_check if it is True it will create as many reinforcement bars as given by amount_spacing_value; if it is False it will create reinforcement bars separated by the numerical value of amount_spacing_value.
  • amount_spacing_value specifies the number of reinforcement bars, or the value of the separation between them, depending on amount_spacing_check.
  • orientation specifies the orientation of the rebar; it can be "Bottom", "Top", "Left", or "Right".

Example

import FreeCAD, Arch, BentShapeRebar

Structure = Arch.makeStructure(length=1000, width=1000, height=100)
Structure.ViewObject.Transparency = 80
FreeCAD.ActiveDocument.recompute()

Rebar = BentShapeRebar.makeBentShapeRebar(50, 20, 20, 20,
                                          8, 40, 100, 135, 2, True, 4, "Bottom", Structure, "Face4")
Rebar.ViewObject.ShapeColor = (0.9, 0.0, 0.0)

Rebar2 = BentShapeRebar.makeBentShapeRebar(50, 40, 20, 20,
                                           8, 20, 100, 135, 2, True, 4, "Bottom", Structure, "Face6")
Rebar2.ViewObject.ShapeColor = (0.0, 0.0, 0.9)

Edition of the rebar

You can change the properties of the rebar with the following function

editBentShapeRebar(Rebar, f_cover, b_cover, l_cover, r_cover,
                   diameter, t_cover, bentLength, bentAngle, rounding, amount_spacing_check, amount_spacing_value, orientation,
                   structure=None, facename=None)
  • Rebar is a previously created BentShapeRebar object.
  • The other parameters are the same as required by the makeBentShapeRebar() function.
  • structure and facename may be omitted so that the rebar stays in the original structure.
import BentShapeRebar

BentShapeRebar.editBentShapeRebar(Rebar, 50, 20, 20, 20,
                                  12, 20, 100, 155, 2, True, 6, "Top")

BentShapeRebar.editBentShapeRebar(Rebar2, 50, 35, 20, 20,
                                  12, 35, 100, 155, 2, True, 6, "Top")